.\$Id: qdata.man,v 1.8 2002/01/21 16:59:23 doug Exp $ 
.TH qdata 1 "18 Jan 2002" BDSN
.SH NAME
qdata - retrieve MiniSEED data
.SH SYNOPSIS
.B qdata
[\ \fB\-f\ \fIdate_time\fR\ ]
[\ \fB\-t\ \fIdate_time\fR\ ]
[\ \fB\-s\ \fItime_span\fR ]
[\ \fB\-o\ \fIoutput_file\fR\ ]
[\ \fB\-n\fR\ ]
[\ \fB\-T\fR\ | \fB\-I\fR\ ]
[\ \fB\-C\fR\ ]
[\ \fB\-B\fR\ ]
[\ \fB\-E\fR\ ]
[\ \fB\-O\fR\ ]
[\ \fB\-P\fR\ ]
[\ \fB\-p\fR\ ]
[\ \fB\-R\ \fIreject_sncl_list\fR\ ]
[\ \fB\-D j\ \fR|\ \fBm\fR\ ]
[\ \fB\-l\ \fIlibdir\fR\ ]
[\ \fB\-d\ \fInum\fR\ ]
[\ \fB\-h\fR\ ]
.I [\ stations [\ channels_1 ... channels_n\fR\ ]] |
.I sncl_list
.br
.SH DESCRIPTION
The program
.B qdata
extracts an interval of Mini-SEED data records from its various archives.  The
output data files, one for each station/channel, consist of 4Kbyte MiniSEED
records that span the specified continuous time interval.
.SH OPTIONS
.TP
\fB\-f \fIdate_time\fR
.br
specifies a beginning (from) time window for which data is desired.  All
data before this time will be ignored.
.TP  
\fB\-t \fIdate_time\fR
.br
specifies an end (to) time window for which data is desired.  
Any data record that starts at or after this time will be ignored.
The end date_time is non-inclusive, so that data will be output up to but
not including the final date_time.  The format for specifying the to and from
date_times are: 
.nf
        yyyy/mm/dd/hh:mm:ss.ffff
        yyyy/mm/dd.hh:mm:ss.ffff
        yyyy/mm/dd,hh:mm:ss.ffff
        yyyy.ddd.hh:mm:ss.ffff
        yyyy.ddd,hh:mm:ss.ffff
        yyyy,ddd,hh:mm:ss.ffff
.fi
where the first format specifies the year, month, day, and time, and the
second format specifies year, julian day, and time.  All trailing components
of the date_time are optional, and if not specified, are assumed to be 0.
.TP
\fB\-s \fItime_span\fR
specifies a time_span (duration) in either seconds, minutes, hours, or days,
and is an alternate way of specifying the end of a time interval.
The time_span is an integer followed immediately by the character 
\fBS\fR, \fBM\fR, \fBH\fR, or \fBd\fR.  If no character is specified, 
seconds are assumed.  This option is mutually exclusive with the \fI-t\fR 
option, and must be used with the \fI-f\fR option.
.TP
\fB\-o \fIoutput_file\fR 
specifies the name of the output file to contain all of the data from this
request.  If the output filename is '-', the data is written to stdout.  If this
option is not used, data for each station-channel is written to a separate
file whose name is generated from the station, network, channel, and start
time of the data request.
.TP
\fB\-n\fR 
specifies that no output files should be created.  Use this option to scan
the data to determine actual data availability or to receive debugging
information about the data channel. 
.TP
\fB\-T\fR\ | \fB\-I\fR
specifies whether timeseries should be trimmed  to specified time period (-T)
or whether the timeseries should include all data in the MiniSEED data 
records that include the specified time period (-I).
The default option is -T.
.TP
.B \-C
forces the program to look only for current data, eg data that is still
within the data acquisition system.  No attempt will be made to access the
archive of extracted data.
.TP
.B \-B
retrieve data from the backup telemetry data directories instead of the normal
telemetry data directories.  The archive of extracted data will also be
accessed unless the \fB-C\fR option is also used.
.TP
.B \-E \fR(obsolete)
retrieve high-frequency (40 Hz) electro-magnetic data from the
electro-magnetic data directories instead of the normal seismic data
directories.  The low frequency data is archived with the normal seismic data,
and you should not use this option when retrieving the low frequencey e-m data.
The archive of extracted data will also be accessed unless the
\fB-C\fR option is also used.
.TP
\fB\-O\fR 
specifies that filenames should be created in the old-style format that does not
contain network code in the filename.
.TP
\fB\-P\fR
prints on stdout the date,time of the beginning of preliminary data
(ie data that has not been reviewed for timing problems).
.TP
\fB\-p\fR
specifies that the actual extraction commands should be printed instead of
executed.  This is useful for debugging purposes.
.TP
\fB\-R \fIreject_sncl_list\fR
specifies a comma-delimited list of sncls to reject.
Channel names may include wildcard characters.
This option can be used to filter out channels that are being
archived but that you do not want to extract.
.TP
\fB-D j|m\fR
prints dates in julian(year.day-of-year) or month (year/month/day) format.
The default format is julian.
.TP
\fB\-l \fIlibdir\fR
specifies an alternate directory containing the configuration files
qdata.channels and qdata.nets.
.TP
\fB\-d \fInum\fR
specifies debugging information should be displayed.  See \fBqmerge\fR
for more details on its debugging options.
.TP
.B \-h
prints out a simple help message with syntax and explanation of the options.
.TP
\fIstations\fR (depricated syntax)
is a comma-separated list of stations for which the data should be extracted.  
Unix wildcard characters (*?) can be used in this list if it enclosed in quotes.
The string "*" or ALL may be used to specify all known stations.
.TP
\fIchannels_1 ... channels_n\fR (depricated syntax)
are one or more comma-separated lists of SEED data channels to be extracted.
You must specify at least 1 channel of data.  
Unix wildcard characters (*?) can be used in a list if it enclosed in quotes.
The string "*" or ALL may be used to specify all known channels.
.TP
.I sncl_list
is a list of one or more 
.I station.network.channel.location 
(abbreviated at \fIsncl\fR) specifiers.
Each component of the sncl may be a comma-separated list of tokens.
A blank location code may be specified as \fB"-"\fR or the empty token.
The resulting sncl list is a cross product of comma-delimted portions
of each component.  For example, the single sncl_list
.nf
	CMB,SAO.BK.BH?,LH?.
.fi
will expand to the following sncl identifiers:
.nf
	CMB.BK.BH?. CMB.BH.LH?. SAO.BK.BH?. SAO.BK.LH?.
.fi

.SH NOTES
1.  All dates must now be specified with a 4-digit year.

2.  The \fB-f\fR option and either the \fB-t\fR or \fB-s\fR option MUST be
specified. 

3.  If the data was requested using the \fIsncl\fR list,
the output data files are created with filenames of the format:
.br
	STATION.NETWORK.CHANNEL.LOCATION.D.YYYY.DDD.HHMMSS
.br
where STATION, NETWORK, CHANNEL, and LOCATION represent the uppercase station,
network, channel, and location fields of the data, the letter \fBD\fR
designates the file as a data file, and YYYY.DD.HHMMSS represent the full year,
day-of-year, hour, minute, and second of the data request.

4.  If the data was requested using the depricated station and channel list, 
the output data files are created with filenames of the format:
.br
	STATION.CHANNEL.D.YYYY.DDD.HHMMSS
.br

.SH EXAMPLES
.nf
qdata -f 1998.176,11:43 -s 10M MHC BHZ BHN BHE
qdata -f 1998.176,11:43 -s 10M MHC BHZ,BHN,BHE
qdata -f 1998.176,11:43 -s 10M MHC.BK.BHZ,BHN,BHE.
qdata -f 1998.176,11:43 -s 10M MHC 'BH*'
	Get 10 minutes of BH data from MHC.
qdata -f 1998.176,11:43 -s 10M 'MHC,SAO.BK.BH*,LH*'
	Get 10 minutes of BH and LH data from MHC and SAO.
qdata -f 1998.176,11:43 -s 4H ARC.BK.VH{Z,N,E}.
	Get 4 hours of VH data from ARC.
qdata -f 1998.176,11:43 -s 2M BKS.BK.HHZ,HHN,HHE,HLZ,HLN,HLE
	Get 2 minutes of HH and HL data from BKS.
qdata -f 1998.176,11:43 -t 1998,176,11:45 BKS,STAN.BK.HH{Z,N,E}
	Get 2 minutes of HH data from BKS and STAN.
qdata -f 2000.176,11:43 -s 1H ALL.BK.LH{Z,N,E}
qdata -f 2000.176,11:43 -s 1H '*.BK.LH?'
	Get 1 hour of LH data from all stations.
qdata -f 2000.176,11:43 -s 1H CMB.BK.LHZ.
	Get 1 hour of LHZ data from a specific channel
.sp
Note that braces will not work with the Bourne shell.
.ad
.SH FILES
.TP 
/usr/local/lib/qdata.nets
.br
is a perl source file containing initialization information that describes
where and how data is stored for each known network.
.sp
.nf
# Qdata runtime include file.
# Perl Hash containing records info for each network.

%netinfo = (
# BK information.
    BK => {
	# Info provided in config file.
	archive	=> [ qw(/data/sam/bbdata/stage /data/sam/bbdata) ],
	dialup	=> [ qw(/data/aq01/dialup.comp) ],
	prelim	=> [ qw(/data/aq01/data /data/aq02/data /data/aq05/data /data/aq06/data) ],
	alt	=> [ qw(/data/aqb1/data) ],
	span	=> "doy",
	locinname => 0,
	# Info derived from the request at runtime.
	datelist  => [ ],
	datadirs  => [ ],
	dialdates => [ ],
	mrecent => "",
    },
# UL information.
    UL => {
	# Info provided in config file.
	archive	=> [ qw(/data/sam/data/UL) ],
	dialup	=> [ ],
	prelim	=> [ ],
	alt	=> [ ],
	span	=> "month",
	locinname => 1,
	# Info derived from the request at runtime.
	datelist  => [ ],
	datadirs  => [ ],
	dialdates => [ ],
	mrecent	=> "",
    },
);
.ad
.TP 
/usr/local/lib/qdata.channels
.br
is file containing a list of all known data channels in SNCL format, one data
channel per line, which qdata uses to expand wildcard characters ("*" and "?")
within the user-specified SNCL.
.sp
.nf
CMB.BK.BHE.
CMB.BK.BHN.
CMB.BK.BHZ.
CMB.BK.HHE.
CMB.BK.HHN.
CMB.BK.HHZ.
CMB.BK.HLE.
CMB.BK.HLN.
CMB.BK.HLZ.
CAGYR.UL.RAX.A0
CAGYR.UL.RAX.A1
CAGYR.UL.RAY.A0
CAGYR.UL.RAY.A1

.SH SEE ALSO
.BR qmerge (1)
.SH AUTHOR
Doug Neuhauser, UC Berkeley Seismological Laboratory, doug@seismo.berkeley.edu
